package domowe.r4.pan_tadeusz;

import java.io.File;
import java.io.FileNotFoundException;
import java.util.LinkedHashMap;
import java.util.Map;
import java.util.Scanner;

public class PoliczWszystkieSlowa_v3 {
    // W tej wersji stosuję nowe (Java 8) "funkcyjne" operacje:
    // - forEachRemaining, która zastpuje nam pętlę while i w inny sposób pozwala przejść przez słowa
    // - merge, która aktualizuje zawartość słownika
    // - wypisywanie wyników też za pomocą funkcyjnego forEach
    // W tej wersji nie są jeszcze używane strumienie.
    
    public static void main(String[] args) {
        Map<String, Integer> slownik = new LinkedHashMap<>();
        
        try(Scanner scanner = new Scanner(new File("pliki/pan_tadeusz.txt"))) {
            scanner.useDelimiter("[^\\p{L}\\d]+");
            scanner.forEachRemaining(slowo -> slownik.merge(slowo, 1, Integer::sum));
        } catch(FileNotFoundException e) {
            e.printStackTrace();
        }
        
        slownik.forEach((k, v) -> {
            System.out.println(k + " → " + v);
        });
    }

}
